# 《2018 年小米高级 PHP 工程师面试题（模拟考试卷）》答案解析


#### [转载来源---微信公众号：PHP在线](https://mp.weixin.qq.com/s/41dl8C1QSglR4HBzoxNUyw)

##### 1、通过哪一个函数，可以把错误转换为异常处理？

`A：set_error_handler `
 `B：error_reporting `
 `C：error2exception `
 `D：catch`

###### 正确答案：A 答案分析：set_error_handler() 可指定一个回调函数，错误发生时，会自动通过指定的回调函数处理。在回调函数中抛出新的异常即可。

##### 2、下列哪个shell函数的描述是正确的?

`A：shell函数可以先调用后定义 `
`B：shell函数需使用关键字function定义 `
`C：shell函数内的变量可以声明为局部变量 `
`D：shell函数只能通过return返回值，1是成功，0是失败 
`

###### 正确答案：C 答案分析：shell函数必须先定义在调用；声明时，无需使用关键字；通过local可以定义函数内的局部变量；shell函数返回值，0是成功，非0是错误，其他选项正确


##### 3、下列关于全文检索技术的说法，不对的是：
`A: Solr是新一代的全文检索组件，它比Lucene的搜索效率高很多，还能支持HTTP的访问方式，PHP调用Solr也很方便。 `
`B: MySQL中把一个字段建立FULLTEXT索引，就可以实现全文检索，目前MyISAM和InnoDB的table都支持FULLTEXT索引。 `
`C: Sphinx是一个基于SQL的全文检索引擎，可以结合MySQL做全文搜索，它可以提供比数据库本身更专业的搜索功能。 `
`D: Lucene附带的二元分词分析器CJKAnalyzer切词速度很快，能满足一般的全文检索需要。
`

###### 正确答案：A 答案分析： Solr是新一代的全文检索组件，它基于Lucene，所以说它比Lucene快就是胡扯 ：）

##### 4、关于单例模式的说法，错误的是？

`A：单例模式的目的是确保在全局环境中，一个类只能有一个实例存在 `
`B：单利模式一般要讲构造函数设置为 private `
`C：只需要将构造函数设置为private 即可确保全局中只有一个实例 `
`D：连接数据库的功能通常用单例模式实现
`

###### 正确答案：C 答案分析：构造函数设置为private，仅能确保无法通过 new 创建新实例，但仍可以通过 clone、反序列化等方式创建多个实例。

##### 5、正则的引擎表述错误的是？

`A 正则引擎主要可以分为两大类：一种是DFA，一种是NFA。`
`B 一般而论，NFA引擎则搜索更快一些。但是DFA以表达式为主导，更容易操纵，因此一般程序员更偏爱DFA引擎！` 
`C NFA表达式主导,DFA文本主导. `
`D 可以使用是否支持忽略优先量词和分组捕获来判断引擎类型：支持 NFA,不支持 DFA
`

###### 正确答案：B
答案分析：正确的说法应该是：一般而论，DFA引擎则搜索更快一些。但是NFA以表达式为主导，更容易操纵，因此一般程序员更偏爱NFA引擎！


##### 6、方框中的正则表达式能与以下哪些选项匹配？

`/.*\*123\d/`
`A．**123 `
`B．****1234 `
`C．1234 `
`D．_*123
`

###### 正确答案：C
答案分析：本题的要点是理解这个正则表达式的含义——从左往右，首先是零个或多个任意字符（.），跟着是一个星号（），然后是 123，最后是一个数字。因此答案是C。


##### 7、如下关于数据库的说法，哪个是错误的？

`A：为了效率数据库可以有多个读库 `
`B：数据库可以用主从做热备` 
`C：数据库不能提供多主多从架构 `
`D: 数据库主从是通过日志同步的
`

###### 正确答案：C
答案分析： 数据库可以提供多主多从架构。


##### 8、下面哪个不是XSS漏洞的修复方式？

`A:对参数进行htmlspecialchas过滤 `
`B:对参数使用白名单过滤 `
`C:不允许输入的内容显示到浏览器 `
`D:禁止在js标签内输出用户输入的内容
`

##### 正确答案：A 这类过滤可以解决尖括号类型的xss，无法解决js标签内的xss
##### 9、下列哪一项不是PHP SAPI模式？
`A.ISAPI `
`B.CGI `
`C.FastCGI `
`D.RESTFUL APi
`

###### 正确答案：D
答案分析：A~C是最常用的模式，D是一种接口的组织方式。


##### 10、对一个大文件进行逐行遍历，如下方法性能较高的是？

`A：写一个实现了IteratorAggregate 接口的类，通过该类使用foreach遍历。` `B：使用file_get_contents 将文件内容一次性载入内存，然后逐行遍历。 `
`C：通过exec函数，调用shell 工具遍历 `
`D：使用别人写的类库
`

###### 正确答案：A
答案分析：使用 IteratorAggregate 可将文件打开后通过移动指针的方式逐行遍历，不受文件大小影响。使用 file_get_contents 处理大文件很容易导致PHP内存溢出；调用exec 会产生额外的进程，影响性能；其他人写的类库质量不一定高。


##### 11、如下选项，哪个不是设计模式应该遵循的原则？

`A：组合优于继承 `
`B：针对接口编程 `
`C：尽可能降低耦合 `
`D：尽量使用高性能的语法 
`

###### 正确答案：D
答案分析：设计模式的关注点在于代码的可维护性和可复用性，D选项不是设计模式关注的要点。


##### 12、下列关于回溯的表达式错误的是？
`A ab.lmn 匹配 abcdeflmnghijklmn 中的 abcdeflmnghijklmn `
`B ab.?lmn 匹配 abcdeflmnghijklmn 中的 abcdeflmn `
`C ab??c 匹配 abcdeflmnghijklmn 中的 abc `
`D .*lmn 匹配 abcdeflmnghijklmn 中的 abcdeflmn
`

##### 正确答案：D
答案分析：D是贪婪匹配，所以应该匹配到的结果是abcdeflmnghijklmn

##### 13、函数中如果使用了try catch finally 语法结构，return 应该写在哪儿？

`A：finally 中` `B：try 中` `C：catch 中` `D：任意位置
`

##### 正确答案：A
答案分析：try 中 return 后 finally 会继续执行，如果 finally 中也有return，则最终返回值为 finally 中 return 的值。

##### 14、以下关于NOSQL的说法，不对的是：

`A: Redis支持字符串、哈希、列表、集合、有序集合等数据结构，目前Redis不支持事务。` 
`B: MongoDB支持CAP定理中的AP，MySQL支持CAP中的CA，全部都支持不可能存在。 `
`C: MongoDB不用先创建Collection的结构就可以直接插入数据，目前MongoDB不支持事务。` 
`D: Memcache既支持TCP协议，也支持UDP协议，我们可以把PHP的Session存放到Memcache中。
`

###### 正确答案：A
答案分析：Redis支持事务。

##### 15、Innodb 锁机制说法错误的是？

`A：Innodb提供了表锁与行锁两种锁机制 `
`B：Innodb的表锁所会在表变更的时候触发 `
`C：Innodb下update时会自动给涉及到的行加上排他锁，并创建出一个镜像副本， 此时进行select 时查询的是镜像副本的数据 `
`D：Innodb行锁状态下读不受影响，写会受影响（涉及到的数据）
`
###### 正确答案：A

##### 16、下列哪个是创建一个每周三01:00~04:00每3分钟执行执行一次的crontab指令？
`A： 1,4 3 /bin/bash /home/sijiaomao/ok.sh `
`B：/3 1,4 * 3 /bin/bash /home/sijiaomao/ok.sh `
`C：/3 1-4 * 3 /bin/bash /home/sijiaomao/ok.sh `
`D：/3 1-4 * * * /bin/bash /home/sijiaomao/ok.sh
`
###### 正确答案：C
答案分析：
A：每周三的1时4时每分钟执行一次 
B：每周三的1时4时每3分钟执行一次 
C：满足要求 
D：每天的1时4时每3分钟执行一次

##### 说明：需要注意的是，C选项存在问题，crontab的基本格式是这样的：分`　 时　 日　 月　 周　` 命令
正确的格式应该是：/3   1-4 * * 3 /bin/bash /home/sijiaomao/ok.sh ，具体解释请看[crontab的笔试题随想1 ](https://www.cnblogs.com/cmderq/p/10165674.html)或者是[crontab的笔试题随想2 ](https://blog.csdn.net/whq19890827/article/details/85226340)

##### 17、在拆分之前，系统中很多列表和详情页所需的数据是可以通过sql join来完成的。而拆分后，数据库可能是分布式在不同实例和不同的主机上，join将变得非常麻烦。下面哪种方法不能有效解决这个问题？

`A 全局表,系统中所有模块都可能会依赖到的一些表在各个库中都保存。 `
`B 字段冗余,“订单表”中保存“卖家Id”的同时，将卖家的“Name”字段也冗余，这样查询订单详情的时候就不需要再去查询“卖家用户表”。`
`C 主从复制,将数据库的读写分离。` 
`D 数据同步,定时A库中的tbl_a表和B库中tbl_b关联，可以定时将指定的表做主从同步。
`

###### 正确答案：C
答案分析：主从复制,将数据库的读写分离。只能扩容读并发，并不能缓解跨库join的问题。

##### 18、关于网络IO模型，下列哪一项是正确的？

`A.Select比Epoll更快 `
`.nginx使用的是select模型 `
`C.apache支持select和epoll两种方式的切换 `
`D.epoll能支持更大的并发
`

###### 正确答案：D
答案分析：A epoll更快一些。B nginx使用epoll模型。C apache只支持select

##### 19、PHP执行的时候有如下执行过程：Scanning(Lexing) - Compilation - Execution - Parsing，其含义分别为：

`A：将PHP代码转换为语言片段(Tokens)、将Tokens转换成简单而有意义的表达式、将表达式编译成Opocdes、顺次执行Opcodes `
`B：将PHP代码转换为语言片段(Tokens)、将Tokens转换成简单而有意义的表达式、顺次执行Opcodes、将表达式编译成Opocdes `
`C：将PHP代码转换为语言片段(Tokens)、将表达式编译成Opocdes、顺次执行Opcodes、将Tokens转换成简单而有意义的表达式 `
`D：将PHP代码转换为语言片段(Tokens)、将表达式编译成Opocdes、将Tokens转换成简单而有意义的表达式、顺次执行Opcodes
`

###### 正确答案：C
答案分析：正确答案为C，正确的顺序为：Scanning(Lexing)、Parsing、Compilation、Execution
